#! /usr/bin/python

#
# SMTPStatusMessages.py 0.9
#                                                                      
# Copyright (C) 2001,2002 Gerson Kurz (not@p-nand-q.com)
# BSD-Licensed. This is free software, enjoy!

# messages that can be sent during SMTP communication.

status_msgs = {
    'OK_HELP'                       : '214 Help not available. RTFM!\r\n',
    'OK_WELCOME'                    : '220 Shicks! SMTP Service %s ready\r\n',
    'OK_QUIT'                       : '221 Closing transmission channel\r\n',
    'OK_NOOP'                       : '250 OK\r\n',
    'OK_GREETING'                   : '250 Hello %s [%s], pleased to meet you\r\n',
    'OK_FROM_ACCPT'                 : '250 Sender has been accepted\r\n',
    'OK_TO_ACCPT'                   : '250 Receiver has been accepted\r\n',
    'OK_RESET'                      : '250 Session reset\r\n',
    'OK_VERIFY'                     : '250 %s\r\n',
    'OK_DATA_RECV'                  : '250 Data received\r\n',
    'OK_TSFR_START'                 : '354 Start mail input; end with <CRLF>.<CRLF>\r\n',
    'OK_AUTH'                       : '235 Authentication successful\r\n',
    'OK_SEND_AUTH_NEXT'             : '334 %s\r\n',
    'OK_SEND_AUTH_COMPLETED'        : '334 OK\r\n',
    'OK_EHLO'                       : '250-Shicks! SMTP Service %s ready\r\n250-AUTH=LOGIN CRAM-MD5\r\n250-AUTH LOGIN CRAM-MD5\r\n250-SIZE\r\n250-VRFY\r\n250 HELP\r\n',

    'ERR_CMD_UNKNOWN'               : '500 "%s" Syntax error, command unrecognized\r\n',
    'ERR_DOMAIN_REQ'                : '501 HELO requires domain address\r\n',
    'ERR_MISS_FROM'                 : '501 MAIL command without "FROM:"\r\n',
    'ERR_MISS_TO'                   : '501 RCPT command without "TO:"\r\n',
    'ERR_USR_UNKNOWN'               : '550 No user called "%s" known\r\n',
    'ERR_ACC_DENIED'                : '551 Access denied - relaying attempt blocked\r\n',
    'ERR_ACC_DENIED_BY_BLACKLIST'   : '551 Access denied - %s is blacklisted by %s\r\n',
    'ERR_ACC_DENIED_BY_RULE'        : '551 Access denied - host %s is on the local deny-hosts-list\r\n',
    'ERR_ACC_DENIED_UNKNOWN_USER'   : '551 Access denied - %s is not a known user\r\n',
    'ERR_ACC_DENIED_NO_DOMAIN'      : '551 Access denied - you must give a domain name\r\n',
    'ERR_ACC_DENIED_INVALID_DOMAIN' : '551 Access denied - domain "%s" does not resolve\r\n',
    
    'ERR_AUTH_REQ'                  : '530 Authentication required\r\n',
    'ERR_AUTH_TYPE'                 : '504 Unrecognized authentication type\r\n',
    'ERR_AUTH_FAILED'               : '535 Authentication failure\r\n',
    'ERR_UNKNOWN_MBOX'              : '550 Requested action not taken: mailbox unknown\r\n',

    }
