#! /usr/bin/python

#
# maildb.py                                                             
#                                                                      
# Copyright (C) 2001,2002 Gerson Kurz (not@p-nand-q.com)
# BSD-Licensed. This is free software, enjoy!


import sys, socket, SocketServer, MySQLdb, os, string

## TODO: If your MySQL Database is protected by name and password,
## please edit these two variables:

USER_NAME = ""
USER_PASSWORD = ""

class Database:   
    def Connect(self):
        self.connection = MySQLdb.connect(host='localhost',db='maildb',user=USER_NAME,passwd=USER_PASSWORD)
        self.cursor = self.connection.cursor()

    def Select(self,sql):
        result = []
        self.cursor.execute(sql)
        for object in self.cursor.fetchall():
            result.append(list(object))
        return result

    def Commit(self,sql):
        self.cursor.execute(sql)
        self.connection.commit()

    def Disconnect(self):    
        self.cursor.close()
        self.connection.close()
        self.cursor = None
        self.connection = None

def EscapeSqlString(x):
    x = list(x)
    escapemap = {
        "'":"''",
        "\t":"\\t",
        "\r":"\\r",
        "\n":"\\n",
        '"':'\\"',
        '\\':'\\\\',
        '%':'\\%',
#       '_':'\\_'
        }
    for i in range(len(x)):
        if escapemap.has_key(x[i]):
            x[i] = escapemap[x[i]]
    return string.join(x,'')
       
def DbQuery(sql):
    result, db = None, Database()
    db.Connect()
    result = db.Select(sql)
    db.Disconnect()
    return result

def DbCommit(sql):
    db = Database()
    db.Connect()
    db.Commit(sql)
    db.Disconnect()
    return 1

def GetConfigSettings(variable,defaultvalue):
    try:
        return DbQuery("SELECT VALUE FROM settings WHERE VARIABLE='%s'" % variable)[0][0]
    except:
        DbCommit("INSERT INTO settings (VARIABLE,VALUE) VALUES ('%s','%s')" % (variable,defaultvalue))
        return defaultvalue
        
def IsKnownAddress(address):
    "Returns 1 if this is an address of a configured user, or 0 otherwise."
    row = DbQuery("SELECT COUNT(*) FROM addresses WHERE MAIL='%s'" % EscapeSqlString(address))
    return len(row) and row[0][0]

import rotor, binascii

def GetUserID(name):
    "Returns a tuple (userid, password) for a given username"
    result = maildb.DbQuery("SELECT ID,PASSWD FROM users WHERE name='%s'" % name)
    if len(result) >= 1:
        result = result[0]
        result[1] = rotor.newrotor("heinz",42).decrypt(binascii.a2b_hex(result[1]))
        return tuple(result)
    return None, None

