import os, traceback

def MxRecordLookup(hostname):
    "Returns a sorted list of (preference,server) for hostnames' MX record"
    nslookup_binary = None
    result = []
    if os.name == "nt":
        pipe = os.popen(os.path.join(os.environ["WINDIR"], "SYSTEM32\\nslookup.exe") + " -query=mx " + hostname)
        for line in pipe.readlines():
            index = line.find("mail exchanger")
            if index >= 0:
                server = line[index+14:].split()[-1]
                preference = 100
                index = line.find("MX preference = ")
                if index >= 0:
                    preference = int(line[index+16:].split()[0].replace(","," "))
                result.append( (preference, server) )
        pipe.close()
    else:
        pipe = os.popen("/usr/bin/nslookup -silent -query=mx " + hostname)
        for line in pipe.readlines():
            index = line.find("mail exchanger")
            if index >= 0:
                tokens = line[index+16:].split()
                if len(tokens) == 2:
                    tokens[0] = int(tokens[0])
                    result.append( tuple(tokens) )
        pipe.close()
    result.sort()
    return result

